import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class sprite here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class sprite extends Actor
{
    private int speed = 1; //Speed of sprite movement
    private int vSpeed = 0; //Fall speed of sprite
    private int acceleration = 1; //Acceleration of the fall speed of the sprite
    private int jumpStrength = 19; //How high the sprite can jump
    private boolean jumping; //To check if the sprite is jumping
    private boolean facingRight; //To check if the sprite is facing right
    private boolean isKeyPressed; //To check if the user is pressing a key
    private boolean spaceDown; //To check if the user is pressing the space key
    private boolean touchingObstacles; //To check if the sprite is touching an enemy or obstacle
    private Scroller scroll;

    //Knight sprite right movement animation
    private GreenfootImage knightRight1 = new GreenfootImage("knightRight1.png");
    private GreenfootImage knightRight2 = new GreenfootImage("knightRight2.png");
    private GreenfootImage knightRight3 = new GreenfootImage("knightRight3.png");
    private GreenfootImage knightRight4 = new GreenfootImage("knightRight4.png");
    private GreenfootImage knightRight5 = new GreenfootImage("knightRight5.png");
    private GreenfootImage knightRight6 = new GreenfootImage("knightRight6.png");
    private GreenfootImage knightRight7 = new GreenfootImage("knightRight7.png");
    private GreenfootImage knightRight8 = new GreenfootImage("knightRight8.png");
    private GreenfootImage knightRight9 = new GreenfootImage("knightRight9.png");
    private GreenfootImage knightRight10 = new GreenfootImage("knightRight10.png");
    private GreenfootImage knightRight11 = new GreenfootImage("knightRight11.png");
    private GreenfootImage knightRight12 = new GreenfootImage("knightRight12.png");
    private GreenfootImage knightRight13 = new GreenfootImage("knightRight13.png");
    private GreenfootImage knightRight14 = new GreenfootImage("knightRight14.png");
    private GreenfootImage knightRight15 = new GreenfootImage("knightRight15.png");
    private GreenfootImage knightRight16 = new GreenfootImage("knightRight16.png");
    private GreenfootImage knightRight17 = new GreenfootImage("knightRight17.png");
    private GreenfootImage knightRight18 = new GreenfootImage("knightRight18.png");
    private int frame = 1;
    
    //Knight srpite left movement animation
    private GreenfootImage knightLeft1 = new GreenfootImage("knightLeft1.png");
    private GreenfootImage knightLeft2 = new GreenfootImage("knightLeft2.png");
    private GreenfootImage knightLeft3 = new GreenfootImage("knightLeft3.png");
    private GreenfootImage knightLeft4 = new GreenfootImage("knightLeft4.png");
    private GreenfootImage knightLeft5 = new GreenfootImage("knightLeft5.png");
    private GreenfootImage knightLeft6 = new GreenfootImage("knightLeft6.png");
    private GreenfootImage knightLeft7 = new GreenfootImage("knightLeft7.png");
    private GreenfootImage knightLeft8 = new GreenfootImage("knightLeft8.png");
    private GreenfootImage knightLeft9 = new GreenfootImage("knightLeft9.png");
    private GreenfootImage knightLeft10 = new GreenfootImage("knightLeft10.png");
    private GreenfootImage knightLeft11 = new GreenfootImage("knightLeft11.png");
    private GreenfootImage knightLeft12 = new GreenfootImage("knightLeft12.png");
    private GreenfootImage knightLeft13 = new GreenfootImage("knightLeft13.png");
    private GreenfootImage knightLeft14 = new GreenfootImage("knightLeft14.png");
    private GreenfootImage knightLeft15 = new GreenfootImage("knightLeft15.png");
    private GreenfootImage knightLeft16 = new GreenfootImage("knightLeft16.png");
    private GreenfootImage knightLeft17 = new GreenfootImage("knightLeft17.png");
    private GreenfootImage knightLeft18 = new GreenfootImage("knightLeft18.png");
    private int frame2 = 1;
    
    public int getHeight()
    {
        return getImage().getHeight();
    }
    public void act() 
    {
       //Main program where multiple methods make the game functional
       checkKeys(); //Calls checkKeys() method
       checkFall(); //Calls checkFall() method
       platformAbove(); //Calls platformAbove() method
       checkRightWalls(); //Calls checkRightWalls() method
       checkObstacles(); //Calls checkObstacles() method
       levelCompletedScreen(); //Calls levelCompletedScreen() method
    }
    
    public void stopWalking()
    {
        //The stopWalking() method is called to prevent the sprite from walking when a key is not pressed 
        setLocation(getX(), getY());
    }
    
    private void checkKeys()
    {
        //The checkKeys() method makes they controls for the game functional
        isKeyPressed = false;
        if (Greenfoot.isKeyDown("a")&&(Greenfoot.isKeyDown("d"))) //When both "a" and "d" keys are pressed at the same time then stop sprite from moving.
        {
            stopWalking();
        }
        else if (Greenfoot.isKeyDown("d")) //If the "d" key is pressed then move the sprite to the right
        {
            moveRight(); //Calls the moveRight() method to make the sprite move right and to animate the sprite movement
            isKeyPressed = true;
            facingRight = true; //Since the sprite will be facing right when the "d" key is pressed the facingRight variable will change to True
        }
        else if (Greenfoot.isKeyDown("a")) //If the "a" key is pressed then move the sprite to the left
        {
            moveLeft(); //Calls the moveLeft() method to make the sprite move left and to animate the sprite movement
            isKeyPressed = true;
            facingRight = false; //facingRight will be false because the sprite will be facing left when the "a" key is pressed
        }
        if(Greenfoot.isKeyDown("w")&& jumping == false) //If the sprite is not jumping and the "w" key is pressed then make the sprite jump
        {
            isKeyPressed = true;
            jump(); //Calls the jump() method to make the sprite jump
        }
        if(!spaceDown && Greenfoot.isKeyDown("space")) //If they space key is pressed and spaceDown is false then shoot a ninja star
        {
            spaceDown = true;
            shruikenRight right = new shruikenRight(); //The shruikenRight() class is called
            shruikenLeft left = new shruikenLeft(); //The shruikenLeft() class is called
            if(facingRight == true) //If the sprite is facing right then shoot the ninja star to the right
            {
                getWorld().addObject(right, getX(), getY()); //Adds the ninja star object and shoots it to the right
            }
            if(facingRight == false) //If the sprite is facing left then shoot the ninja star to the left 
            {
                getWorld().addObject(left, getX(), getY()); //Adds the ninja star object and shoots it to the left
            }
        }
        if(spaceDown && !Greenfoot.isKeyDown("space")) //If spaceDown is true and the space key is not pressed then change spaceDown to false
        {
            spaceDown = false;
        }
        if (!isKeyPressed) //If no key is pressed then make the sprite stop walking
        {
            stopWalking(); //Calls the stopWalking() method which makes the sprite stop walking
        }
    }
    
    public void jump() 
    {
        //The jump() method allows the sprite to jump and once the sprite jumps it will move back to the ground
        vSpeed = vSpeed - jumpStrength; //vSpeed which is short for velocity speed is equal to vSpeed subtracted by jumpStrength
        fall(); //Calls the fall() method which makes the sprite return back to the ground
    }
    
    public void moveRight()
    {
        //The method allows the sprite to move to the right and it animates the sprite movement
        setLocation(getX() + speed, getY()); //Makes the sprite to the right by adding the X position for the sprite by the speed variable
        animateRight(); //Calls the animateRight() method which animates the sprite movement
    }
    
    public void moveLeft()
    {
        //This method allows the sprite to move to the right and it animates the sprite movement
        setLocation(getX() - speed, getY()); //Makes the sprite move to the left by subtracting the X position for the sprite by the speed variable
        animateLeft(); //Calls the animateLeft() method which animates the sprite movement
    }
    
    private void fall()
    {
        //If vSpeed is less than or equal to 9 then add the vSpeed variable with the acceleration variable
        setLocation(getX(), getY() + vSpeed);
        if (vSpeed <=9)
        {
            vSpeed = vSpeed + acceleration; 
        }
        jumping = true;
    }
    
    private void checkFall()
    {
        //This method is to check if the sprite is falling or on the ground
        
        //If the sprite is on the ground then set vSpeed to 0 other than that call the fall() method
        if(onGround())
        {
            vSpeed = 0;
        }
        else
        {
            fall();
        }
    }  
    
    public boolean onGround()
    {
        //This method explains to the sprite() class what the ground is
        int spriteHeight = getImage().getHeight();
        int yDistance = (int)(spriteHeight / 2 + 5);
        
        Actor ground = getOneObjectAtOffset(0, getHeight()/2, block2.class);
        Actor ground2 = getOneObjectAtOffset(0, getHeight()/2, boxPlatform.class);
        if(ground == null)
        {
            return false;
        }
        else
        {
            moveToGround(ground);
            return true;
        }
    }
    
    public void moveToGround(Actor ground)
    {
        //This method moves the sprite to the ground
        int groundHeight = ground.getImage().getHeight();
        int newY = ground.getY() - (groundHeight + getImage().getHeight())/2;
        setLocation(getX(), newY);
        jumping = false;
    }
    
    public boolean platformAbove()
    {
        //This method explains to the sprite() class what a platform above it is
        int spriteHeight = getImage().getHeight();
        int yDistance = (int)(spriteHeight / -2);
        
        Actor ceiling = getOneObjectAtOffset(0, yDistance, block2.class);
        if(ceiling != null)
        {
            vSpeed = 1;
            bopHead(ceiling);
            return true;
        }
        else
        {
            return false;
        }
    }
    
    public void bopHead(Actor ceiling)
    {
        //This method stops the sprite from travelling through a platform that is above it
        int ceilingHeight = ceiling.getImage().getHeight();
        int newY = ceiling.getY() + (ceilingHeight + getImage().getHeight())/2;
        setLocation(getX(), newY);
    }
    
    public boolean checkRightWalls()
    {
        //This method explains to the sprite() class what the side of block is
        int spriteWidth = getImage().getHeight();
        int xDistance = (int)(spriteWidth/2);
        Actor rightWall = getOneObjectAtOffset(xDistance, 0, block2.class);
        if(rightWall == null)
        {
            return false;
        }
        else
        {
            stopByRightWall(rightWall);
            return true;
        }
    }
    
    public void stopByRightWall(Actor rightWall)
    {
        //This method stops the sprite from travelling through the side of a block
        int wallWidth = rightWall.getImage().getWidth();
        int newX = rightWall.getX() - (wallWidth + getImage().getWidth())/2;
        setLocation(newX -5, getY());
    }
    
    public boolean canSee(Class clss){
        Actor actor = getOneIntersectingObject(clss);
        return actor != null;     
    }
    
    public void checkObstacles()
    {
        //This method checks if the sprite is touching an enemy or an obstacle
        
        Actor obstacles = getOneIntersectingObject(OBSTACLES.class);
        if (obstacles != null)
        {
            if(touchingObstacles == false)
            {
                //If the sprite is touching an enemy or an obstacle then subtract the lives counter by one
                ((MyWorld)getWorld()).getLives().subtractLives();
                setLocation(25,0); //Makes the sprite respawn after losing a life
                touchingObstacles = true;
            }
        } 
        else
        {
            touchingObstacles = false;
        }
    }
    
    public void levelCompletedScreen()
    {
        //If the sprite is touching the portal object then call the levelCompleted() method from the MyWorld() class
        if (isTouching(portal.class))
        {
            ((MyWorld)getWorld()).levelCompleted();
        }
    }
    
    public void animateRight()
    {
        //This method animates the sprite when it moves to the right
        if(frame == 1)
        {
            setImage(knightRight1);
        }
        else if(frame == 2)
        {
            setImage(knightRight2);
        }
        else if(frame == 3)
        {
            setImage(knightRight3);
        }
        else if(frame == 4)
        {
            setImage(knightRight4);
        }
        else if(frame == 5)
        {
            setImage(knightRight5);
        }
        else if(frame == 6)
        {
            setImage(knightRight6);
        }
        else if(frame == 7)
        {
            setImage(knightRight7);
        }
        else if(frame == 8)
        {
            setImage(knightRight8);
        }
        else if(frame == 9)
        {
            setImage(knightRight9);
        }
        else if(frame == 10)
        {
            setImage(knightRight10);
        }
        else if(frame == 11)
        {
            setImage(knightRight11);
        }
        else if(frame == 12)
        {
            setImage(knightRight12);
        }
        else if(frame == 13)
        {
            setImage(knightRight13);
        }
        else if(frame == 14)
        {
            setImage(knightRight14);
        }
        else if(frame == 15)
        {
            setImage(knightRight15);
        }
        else if(frame == 16)
        {
            setImage(knightRight16);
        }
        else if(frame == 17)
        {
            setImage(knightRight17);
        }
        else if(frame == 18)
        {
            setImage(knightRight18);
            frame = 1;
            return;
        }
        
        frame ++;
    }    
    
    public void animateLeft()
    {
        //This method animates the sprite when it moves to the left
        if(frame2 == 1)
        {
            setImage(knightLeft1);
        }
        else if(frame2 == 2)
        {
            setImage(knightLeft2);
        }
        else if(frame2 == 3)
        {
            setImage(knightLeft3);
        }
        else if(frame2 == 4)
        {
            setImage(knightLeft4);
        }
        else if(frame2 == 5)
        {
            setImage(knightLeft5);
        }
        else if(frame2 == 6)
        {
            setImage(knightLeft6);
        }
        else if(frame2 == 7)
        {
            setImage(knightLeft7);
        }
        else if(frame2 == 8)
        {
            setImage(knightLeft8);
        }
        else if(frame2 == 9)
        {
            setImage(knightLeft9);
        }
        else if(frame2 == 10)
        {
            setImage(knightLeft10);
        }
        else if(frame2 == 11)
        {
            setImage(knightLeft11);
        }
        else if(frame2 == 12)
        {
            setImage(knightLeft12);
        }
        else if(frame2 == 13)
        {
            setImage(knightLeft13);
        }
        else if(frame2 == 14)
        {
            setImage(knightLeft14);
        }
        else if(frame2 == 15)
        {
            setImage(knightLeft15);
        }
        else if(frame2 == 16)
        {
            setImage(knightLeft16);
        }
        else if(frame2 == 17)
        {
            setImage(knightLeft17);
        }
        else if(frame2 == 18)
        {
            setImage(knightLeft18);
            frame2 = 1;
            return;
        }
        
        frame2 ++;
    }
}
